# coding: utf-8

"""
    Stadia Maps Geospatial APIs

    The Stadia Maps Geospatial APIs provide you with the data you need to build awesome applications.

    The version of the OpenAPI document: 9.2.1
    Contact: support@stadiamaps.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from stadiamaps.models.wof_context import WofContext
from typing import Optional, Set
from typing_extensions import Self

class Context(BaseModel):
    """
    The geographic context for a feature.  Note that while data sources and country codes are listed, this does not *necessarily* mean that the view is a specific hierarchy endorsed by that source. We generally attempt to present the same view as OpenStreetMap. Contact us if your use case requires a specific political view of the world.
    """ # noqa: E501
    iso_3166_a2: Optional[StrictStr] = Field(default=None, description="The ISO 3166-1 alpha-2 country code in which the feature is located.")
    iso_3166_a3: Optional[StrictStr] = Field(default=None, description="The ISO 3166-1 alpha-3 country code in which the feature is located.")
    whosonfirst: WofContext = Field(description="The geographic context, with administrative hierarchy modeled using the Who's on First taxonomy.")
    additional_properties: Dict[str, Any] = {}
    __properties: ClassVar[List[str]] = ["iso_3166_a2", "iso_3166_a3", "whosonfirst"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Context from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * Fields in `self.additional_properties` are added to the output dict.
        """
        excluded_fields: Set[str] = set([
            "additional_properties",
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of whosonfirst
        if self.whosonfirst:
            _dict['whosonfirst'] = self.whosonfirst.to_dict()
        # puts key-value pairs in additional_properties in the top level
        if self.additional_properties is not None:
            for _key, _value in self.additional_properties.items():
                _dict[_key] = _value

        # set to None if iso_3166_a2 (nullable) is None
        # and model_fields_set contains the field
        if self.iso_3166_a2 is None and "iso_3166_a2" in self.model_fields_set:
            _dict['iso_3166_a2'] = None

        # set to None if iso_3166_a3 (nullable) is None
        # and model_fields_set contains the field
        if self.iso_3166_a3 is None and "iso_3166_a3" in self.model_fields_set:
            _dict['iso_3166_a3'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Context from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "iso_3166_a2": obj.get("iso_3166_a2"),
            "iso_3166_a3": obj.get("iso_3166_a3"),
            "whosonfirst": WofContext.from_dict(obj["whosonfirst"]) if obj.get("whosonfirst") is not None else None
        })
        # store additional fields in additional_properties
        for _key in obj.keys():
            if _key not in cls.__properties:
                _obj.additional_properties[_key] = obj.get(_key)

        return _obj


