# coding: utf-8

"""
    Stadia Maps Geospatial APIs

    The Stadia Maps Geospatial APIs provide you with the data you need to build awesome applications.

    The version of the OpenAPI document: 9.2.1
    Contact: support@stadiamaps.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
from enum import Enum
from typing_extensions import Self


class CostingModel(str, Enum):
    """
    A model which influences the routing based on the type of travel. The costing model affects parameters ranging from which roads are legally accessible to preferences based on comfort or speed. See https://valhalla.github.io/valhalla/api/turn-by-turn/api-reference/#costing-models for in-depth descriptions of each costing model.
    """

    """
    allowed enum values
    """
    AUTO = 'auto'
    BUS = 'bus'
    TAXI = 'taxi'
    TRUCK = 'truck'
    BICYCLE = 'bicycle'
    BIKESHARE = 'bikeshare'
    MOTOR_SCOOTER = 'motor_scooter'
    MOTORCYCLE = 'motorcycle'
    PEDESTRIAN = 'pedestrian'
    LOW_SPEED_VEHICLE = 'low_speed_vehicle'

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of CostingModel from a JSON string"""
        return cls(json.loads(json_str))


