# coding: utf-8

"""
    Stadia Maps Geospatial APIs

    The Stadia Maps Geospatial APIs provide you with the data you need to build awesome applications.

    The version of the OpenAPI document: 8.0.0
    Contact: support@stadiamaps.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
import pprint
from pydantic import BaseModel, ConfigDict, Field, StrictStr, ValidationError, field_validator
from typing import Any, List, Optional
from stadiamaps.models.geo_json_line_string import GeoJSONLineString
from stadiamaps.models.geo_json_point import GeoJSONPoint
from stadiamaps.models.geo_json_polygon import GeoJSONPolygon
from pydantic import StrictStr, Field
from typing import Union, List, Set, Optional, Dict
from typing_extensions import Literal, Self

GEOJSONGEOMETRY_ONE_OF_SCHEMAS = ["GeoJSONLineString", "GeoJSONPoint", "GeoJSONPolygon"]

class GeoJSONGeometry(BaseModel):
    """
    GeoJSONGeometry
    """
    # data type: GeoJSONPoint
    oneof_schema_1_validator: Optional[GeoJSONPoint] = None
    # data type: GeoJSONLineString
    oneof_schema_2_validator: Optional[GeoJSONLineString] = None
    # data type: GeoJSONPolygon
    oneof_schema_3_validator: Optional[GeoJSONPolygon] = None
    actual_instance: Optional[Union[GeoJSONLineString, GeoJSONPoint, GeoJSONPolygon]] = None
    one_of_schemas: Set[str] = { "GeoJSONLineString", "GeoJSONPoint", "GeoJSONPolygon" }

    model_config = ConfigDict(
        validate_assignment=True,
        protected_namespaces=(),
    )


    discriminator_value_class_map: Dict[str, str] = {
    }

    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @field_validator('actual_instance')
    def actual_instance_must_validate_oneof(cls, v):
        instance = GeoJSONGeometry.model_construct()
        error_messages = []
        match = 0
        # validate data type: GeoJSONPoint
        if not isinstance(v, GeoJSONPoint):
            error_messages.append(f"Error! Input type `{type(v)}` is not `GeoJSONPoint`")
        else:
            match += 1
        # validate data type: GeoJSONLineString
        if not isinstance(v, GeoJSONLineString):
            error_messages.append(f"Error! Input type `{type(v)}` is not `GeoJSONLineString`")
        else:
            match += 1
        # validate data type: GeoJSONPolygon
        if not isinstance(v, GeoJSONPolygon):
            error_messages.append(f"Error! Input type `{type(v)}` is not `GeoJSONPolygon`")
        else:
            match += 1
        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when setting `actual_instance` in GeoJSONGeometry with oneOf schemas: GeoJSONLineString, GeoJSONPoint, GeoJSONPolygon. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when setting `actual_instance` in GeoJSONGeometry with oneOf schemas: GeoJSONLineString, GeoJSONPoint, GeoJSONPolygon. Details: " + ", ".join(error_messages))
        else:
            return v

    @classmethod
    def from_dict(cls, obj: Union[str, Dict[str, Any]]) -> Self:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Returns the object represented by the json string"""
        instance = cls.model_construct()
        error_messages = []
        match = 0

        # deserialize data into GeoJSONPoint
        try:
            instance.actual_instance = GeoJSONPoint.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into GeoJSONLineString
        try:
            instance.actual_instance = GeoJSONLineString.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into GeoJSONPolygon
        try:
            instance.actual_instance = GeoJSONPolygon.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when deserializing the JSON string into GeoJSONGeometry with oneOf schemas: GeoJSONLineString, GeoJSONPoint, GeoJSONPolygon. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when deserializing the JSON string into GeoJSONGeometry with oneOf schemas: GeoJSONLineString, GeoJSONPoint, GeoJSONPolygon. Details: " + ", ".join(error_messages))
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        if hasattr(self.actual_instance, "to_json") and callable(self.actual_instance.to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> Optional[Union[Dict[str, Any], GeoJSONLineString, GeoJSONPoint, GeoJSONPolygon]]:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        if hasattr(self.actual_instance, "to_dict") and callable(self.actual_instance.to_dict):
            return self.actual_instance.to_dict()
        else:
            # primitive type
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.model_dump())


