# coding: utf-8

"""
    Stadia Maps Geospatial APIs

    The Stadia Maps Geospatial APIs provide you with the data you need to build awesome applications.

    The version of the OpenAPI document: 9.2.1
    Contact: support@stadiamaps.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List, Optional
from stadiamaps.models.maneuver_sign_element import ManeuverSignElement
from typing import Optional, Set
from typing_extensions import Self

class ManeuverSign(BaseModel):
    """
    ManeuverSign
    """ # noqa: E501
    exit_number_elements: Optional[List[ManeuverSignElement]] = Field(default=None, description="A list of exit number elements. This is typically just a single value.")
    exit_branch_elements: Optional[List[ManeuverSignElement]] = Field(default=None, description="A list of exit branch elements. The text is a subsequent road name or route number after the sign.")
    exit_toward_elements: Optional[List[ManeuverSignElement]] = Field(default=None, description="A list of exit name elements. The text is the interchange identifier (used more frequently outside the US).")
    exit_name_elements: Optional[List[ManeuverSignElement]] = Field(default=None, description="A list of exit name elements. The text is the location where the road ahead goes (typically a city, but occasionally a road name or route number).")
    additional_properties: Dict[str, Any] = {}
    __properties: ClassVar[List[str]] = ["exit_number_elements", "exit_branch_elements", "exit_toward_elements", "exit_name_elements"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ManeuverSign from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * Fields in `self.additional_properties` are added to the output dict.
        """
        excluded_fields: Set[str] = set([
            "additional_properties",
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in exit_number_elements (list)
        _items = []
        if self.exit_number_elements:
            for _item_exit_number_elements in self.exit_number_elements:
                if _item_exit_number_elements:
                    _items.append(_item_exit_number_elements.to_dict())
            _dict['exit_number_elements'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in exit_branch_elements (list)
        _items = []
        if self.exit_branch_elements:
            for _item_exit_branch_elements in self.exit_branch_elements:
                if _item_exit_branch_elements:
                    _items.append(_item_exit_branch_elements.to_dict())
            _dict['exit_branch_elements'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in exit_toward_elements (list)
        _items = []
        if self.exit_toward_elements:
            for _item_exit_toward_elements in self.exit_toward_elements:
                if _item_exit_toward_elements:
                    _items.append(_item_exit_toward_elements.to_dict())
            _dict['exit_toward_elements'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in exit_name_elements (list)
        _items = []
        if self.exit_name_elements:
            for _item_exit_name_elements in self.exit_name_elements:
                if _item_exit_name_elements:
                    _items.append(_item_exit_name_elements.to_dict())
            _dict['exit_name_elements'] = _items
        # puts key-value pairs in additional_properties in the top level
        if self.additional_properties is not None:
            for _key, _value in self.additional_properties.items():
                _dict[_key] = _value

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ManeuverSign from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "exit_number_elements": [ManeuverSignElement.from_dict(_item) for _item in obj["exit_number_elements"]] if obj.get("exit_number_elements") is not None else None,
            "exit_branch_elements": [ManeuverSignElement.from_dict(_item) for _item in obj["exit_branch_elements"]] if obj.get("exit_branch_elements") is not None else None,
            "exit_toward_elements": [ManeuverSignElement.from_dict(_item) for _item in obj["exit_toward_elements"]] if obj.get("exit_toward_elements") is not None else None,
            "exit_name_elements": [ManeuverSignElement.from_dict(_item) for _item in obj["exit_name_elements"]] if obj.get("exit_name_elements") is not None else None
        })
        # store additional fields in additional_properties
        for _key in obj.keys():
            if _key not in cls.__properties:
                _obj.additional_properties[_key] = obj.get(_key)

        return _obj


