# coding: utf-8

"""
    Stadia Maps Geospatial APIs

    The Stadia Maps Geospatial APIs provide you with the data you need to build awesome applications.

    The version of the OpenAPI document: 9.2.1
    Contact: support@stadiamaps.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictFloat, StrictInt
from typing import Any, ClassVar, Dict, List, Optional, Union
from stadiamaps.models.osrm_speed_limit import OsrmSpeedLimit
from typing import Optional, Set
from typing_extensions import Self

class OsrmAnnotation(BaseModel):
    """
    OsrmAnnotation
    """ # noqa: E501
    distance: Optional[List[Union[StrictFloat, StrictInt]]] = Field(default=None, description="The distance, in meters, between each pair of coordinates.")
    duration: Optional[List[Union[StrictFloat, StrictInt]]] = Field(default=None, description="The duration between each pair of coordinates, in seconds.")
    weight: Optional[List[StrictInt]] = None
    speed: Optional[List[Union[StrictFloat, StrictInt]]] = Field(default=None, description="The estimated speed of travel between each pair of coordinates in meters/sec.")
    maxspeed: Optional[List[OsrmSpeedLimit]] = None
    additional_properties: Dict[str, Any] = {}
    __properties: ClassVar[List[str]] = ["distance", "duration", "weight", "speed", "maxspeed"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of OsrmAnnotation from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * Fields in `self.additional_properties` are added to the output dict.
        """
        excluded_fields: Set[str] = set([
            "additional_properties",
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in maxspeed (list)
        _items = []
        if self.maxspeed:
            for _item_maxspeed in self.maxspeed:
                if _item_maxspeed:
                    _items.append(_item_maxspeed.to_dict())
            _dict['maxspeed'] = _items
        # puts key-value pairs in additional_properties in the top level
        if self.additional_properties is not None:
            for _key, _value in self.additional_properties.items():
                _dict[_key] = _value

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of OsrmAnnotation from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "distance": obj.get("distance"),
            "duration": obj.get("duration"),
            "weight": obj.get("weight"),
            "speed": obj.get("speed"),
            "maxspeed": [OsrmSpeedLimit.from_dict(_item) for _item in obj["maxspeed"]] if obj.get("maxspeed") is not None else None
        })
        # store additional fields in additional_properties
        for _key in obj.keys():
            if _key not in cls.__properties:
                _obj.additional_properties[_key] = obj.get(_key)

        return _obj


